' ChsFont.inc 	               Dialog zur Fontauswahl anzeigen
' Eine Beschreibung der Prozedur ist in ChsFont.prf enthalten

' Version 2.0  12.4.2010.      Fr Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka   
'                       email: gerhard-putschalka@gmx.at
'                    homepage: http://www.gerhard-putschalka.xprofan.com/index.htm

' folgende Declares mssen global und daher ausserhalb der Prozedur sein.
Declare F_ChsFnt#,F_Fnt#,F_Font$,F_Siz%,F_Kurs%,F_Ulin%,F_Bold%,F_Rot%,F_Grn%,F_Blu%

Def ChooseFont(1) ! "COMDLG32.DLL","ChooseFontA","#","%"

Proc Fontauswahl			' Dialog zur Fontauswahl
   Parameters Font$,Size%,Kurs%,Ulin%,Bold%,Rot%,Grn%,Blu%
	Declare RetCod&,RetCod%,Farbe&
	Farbe& = @Rgb(Rot%,Grn%,Blu%)
	Size% = Size% * 100 / 75	' Fonthhe 1000 entspricht 10

   Dim F_Fnt#,80
   Dim F_ChsFnt#,60

' Struktur TChooseFont
   Long F_ChsFnt#,0 = 60         ' Lnge der Struktur
   Long F_ChsFnt#,4 = %hwnd      ' Handle des Elternfensters (def. Hauptfenster)
   Long F_ChsFnt#,8 = 0          ' Drucker DC/IC
   Long F_ChsFnt#,12= F_Fnt#     ' Zeiger zuLogFontStruktur
   Long F_ChsFnt#,16 = 0         ' 10 * Points  des gewhlten Fonts
   Long F_ChsFnt#,20 = $00002341 ' Dialog Flags
   Long F_ChsFnt#,24 = Farbe&    ' ausgew. Textfarbe
   Long F_ChsFnt#,28 = 0         ' Daten zur Hook Funktion
   Long F_ChsFnt#,32 = 0         ' Zeiger zur Hook Funktion
   long F_ChsFnt#,36=  0         ' Zeiger auf Dialogvorlage
   Long F_ChsFnt#,40=  0         ' Instancehandle
   long F_ChsFnt#,44=  0         ' Schriftschnitt
   Long F_ChsFnt#,48=  $00000001 ' Font Type
   Long F_ChsFnt#,52=  2         ' minimale erlaubte Fontgre
   Long F_ChsFnt#,56=  48        ' maximale erlaubte Fontgre

' Struktur LogFont
   Long F_Fnt#,0=Size%           ' Fonthhe
   Long F_Fnt#,4=20              ' Fontweite (1000 entspricht 10)
   Long F_Fnt#,8=0
   Long F_Fnt#,12=200            ' Font-Orientation
   Long F_Fnt#,16=400            ' ... normal
   String F_Fnt#,20=""
   String F_Fnt#,21=""
   CaseNot (Bold% = 0) : Long F_Fnt#,16=600   ' oder fett
   CaseNot (Kurs% = 0) : String F_Fnt#,20="1" ' kursiv
   CaseNot (Ulin% = 0) : String F_Fnt#,21="1"' unterstrichen
   String F_Fnt#,22=""           ' durchgestrichen (nicht benutzt)
   String F_Fnt#,23="0"          ' Zeichensatz
   String F_Fnt#,24="T"          ' Ausgabequalitt
   String F_Fnt#,25="T"          ' Clipping
   String F_Fnt#,26="0"          ' Qualitt (Schirm)
   String F_Fnt#,27="2"          ' Schriftfamilie
   String F_Fnt#,28=Font$        ' Name der Schrift

   Retcod& = ChooseFont(F_ChsFnt#)
	RetCod% = RetCod&

   'Attribute auslesen
	' die folgenden Variablen sind global definiert und knnen daher ausserhalb
   ' der Prozedur benutzt werden.
   F_Font$ = @string$(F_Fnt#,28)
   F_Siz%  = (@word(F_ChsFnt#,16) / 10)
   F_Kurs%  = @Ord(@string$(F_Fnt#,20))
   F_Ulin%  = @Ord(@string$(F_Fnt#,21))
	CaseNot (F_Kurs% = 0) : F_Kurs% = 1
   If (@Long(F_Fnt#,16) > 600)
      F_Bold% = 1
   else
      F_Bold% = 0
   endif
	F_Rot% = @GetRValue(@long(F_ChsFnt#,24))
	F_Grn% = @GetGValue(@long(F_ChsFnt#,24))
	F_Blu% = @GetBValue(@long(F_ChsFnt#,24))
   Dispose F_ChsFnt#
   Dispose F_Fnt#
   Return RetCod%
EndProc
